Module Module1
    '[1] Global Variables
    Public ErrMsg() As String = { _
         "No_Err", "DEV_ModName_Err", "DEV_ModNotExist_Err", _
         "DEV_PortNotExist_Err", "DEV_PortInUse_Err", "DEV_PortNotOpen_Err", _
         "CAN_ConfigFail_Err", "CAN_HARDWARE_Err", "CAN_PortNo_Err", _
         "CAN_FIDLength_Err", "CAN_DevDisconnect_Err", "CAN_TimeOut_Err", _
         "CAN_ConfigCmd_Err", "CAN_ConfigBusy_Err", "CAN_RxBufEmpty", _
         "CAN_TxBufFull", "CAN_UserDefISRNo_Err" _
    }

    '[2] Global Functions
    Public Sub ShowErrMsg(ByVal ErrNo As Integer)
        MessageBox.Show(ErrMsg(ErrNo), "", MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Sub

    Public Sub PortOpen_BtnFunc()
        With Form1
            .btn_OpenCAN.Enabled = False
            .cbo_ComPort.Enabled = False
            .cbo_DevType.Enabled = False
            .cbo_C1Baud.Enabled = False
            .cbo_C2Baud.Enabled = False
            .cbo_CANNo.Enabled = True
            .btn_SendCANMsg.Enabled = True
            .btn_RecvCANMsg.Enabled = True
            .btn_EnHWCycTxMsg.Enabled = True
            .btn_DisHWCycTxMsg.Enabled = True
            .btn_CANStatus.Enabled = True
            .btn_ClrErrLED.Enabled = True
            .btn_ModInfo.Enabled = True
            .btn_RstMod.Enabled = True
        End With
    End Sub

    Public Sub PortClose_BtnFunc()
        With Form1
            .btn_OpenCAN.Enabled = True
            .cbo_ComPort.Enabled = True
            .cbo_DevType.Enabled = True
            .cbo_C1Baud.Enabled = True
            If .cbo_DevType.SelectedIndex = 0 Then
                .cbo_C2Baud.Enabled = False
            Else
                .cbo_C2Baud.Enabled = True
            End If
            '.cbo_CANNo.Enabled = False
            .btn_SendCANMsg.Enabled = False
            .btn_RecvCANMsg.Enabled = False
            .btn_EnHWCycTxMsg.Enabled = False
            .btn_DisHWCycTxMsg.Enabled = False
            .btn_CANStatus.Enabled = False
            .btn_ClrErrLED.Enabled = False
            .btn_ModInfo.Enabled = False
            .btn_RstMod.Enabled = False
        End With
    End Sub

    Public Sub Show_CmdStatus(ByVal Res As String)
        Form1.lbl_CmdStatus.Text = "Cmd_Status :  " & Res
    End Sub

    Public Function TPFLOATMS(ByVal fVal As Single)
        TPFLOATMS = CLng(fVal * 10) + 100000000
    End Function

End Module


