
// Demo1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo1.h"
#include "Demo1Dlg.h"
#include "VCI_CAN.h"
#include "afxdialogex.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


/* Global Variable */
BYTE ComPort, DevMode, CAN_No;
CString TmpMsg;
int Ret;
DWORD i;
DWORD MyTest0_Val, MyTest1_Val;



/* Global Function */
void MyTestISR0(void)
{
	MyTest0_Val++;
	//AfxMessageBox("MyTestISR0");
}

void MyTestISR1(void)
{
	MyTest1_Val++;
	//AfxMessageBox("MyTestISR1");
}


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CDemo1Dlg dialog




CDemo1Dlg::CDemo1Dlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CDemo1Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemo1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_ComPort, m_ComPort);
	DDX_Control(pDX, IDC_COMBO_DevType, m_DevType);
	DDX_Control(pDX, IDC_COMBO_CANCtrlNo, m_CANCtrlNo);
	DDX_Control(pDX, IDC_COMBO_CANBaud, m_CANBaud);
	DDX_Control(pDX, IDC_COMBO_CANBaud2, m_CANBaud2);
	DDX_Control(pDX, IDC_STATIC_ResStr, m_ResStr);
	DDX_Control(pDX, IDC_BTN_VCI_Set_CANFID_AllPass, m_BtnSetFIDAllPass);
	DDX_Control(pDX, IDC_BTN_SetCANFID, m_BtnSetCANFID);
	DDX_Control(pDX, IDC_BTN_ResetMOD, m_BtnRstMod);
	DDX_Control(pDX, IDC_BTN_CANRecv, m_BtnCANRecv);
	DDX_Control(pDX, IDC_BTN_CANSend, m_BtnCANSend);
	DDX_Control(pDX, IDC_BTN_CloseCAN, m_BtnCloseCAN);
	DDX_Control(pDX, IDC_BTN_ClrBufferFullLED, m_BtnClrBufFullLED);
	DDX_Control(pDX, IDC_BTN_ClrSoftBuffer, m_BtnClrSoftBuf);
	DDX_Control(pDX, IDC_BTN_DisableHWCyclicTxMsg, m_BtnDisHWCyclicTxMsg);
	DDX_Control(pDX, IDC_BTN_GetCANFID, m_BtnGetCANFID);
	//  DDX_Control(pDX, IDC_BTN_GetCANStatus, m_BtnCANSta);
	DDX_Control(pDX, IDC_BTN_GetModInfo, m_BtnGetModInfo);
	DDX_Control(pDX, IDC_BTN_HWCyclic_SendCANMsg, m_BtnEnHWCyclicTxMsg);
	DDX_Control(pDX, IDC_BTN_OpenCom, m_BtnOpenCAN);
	DDX_Control(pDX, IDC_BTN_GetCANStatus, m_BtnGetCANSta);
}

BEGIN_MESSAGE_MAP(CDemo1Dlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_OpenCom, &CDemo1Dlg::OnBnClickedBtnOpencom)
	ON_BN_CLICKED(IDC_BTN_CloseCAN, &CDemo1Dlg::OnBnClickedBtnClosecan)
	ON_BN_CLICKED(IDC_BTN_SetCANFID, &CDemo1Dlg::OnBnClickedBtnSetcanfid)
	ON_BN_CLICKED(IDC_BTN_GetCANFID, &CDemo1Dlg::OnBnClickedBtnGetcanfid)
	ON_BN_CLICKED(IDC_BTN_VCI_Set_CANFID_AllPass, &CDemo1Dlg::OnBnClickedBtnVciSetCanfidAllpass)
	ON_BN_CLICKED(IDC_BTN_GetCANStatus, &CDemo1Dlg::OnBnClickedBtnGetcanstatus)
	ON_BN_CLICKED(IDC_BTN_ClrBufferFullLED, &CDemo1Dlg::OnBnClickedBtnClrbufferfullled)
	ON_BN_CLICKED(IDC_BTN_GetModInfo, &CDemo1Dlg::OnBnClickedBtnGetmodinfo)
	ON_BN_CLICKED(IDC_BTN_ResetMOD, &CDemo1Dlg::OnBnClickedBtnResetmod)
	ON_BN_CLICKED(IDC_BTN_CANSend, &CDemo1Dlg::OnBnClickedBtnCansend)
	ON_BN_CLICKED(IDC_BTN_CANRecv, &CDemo1Dlg::OnBnClickedBtnCanrecv)
	ON_BN_CLICKED(IDC_BTN_HWCyclic_SendCANMsg, &CDemo1Dlg::OnBnClickedBtnHwcyclicSendcanmsg)
	ON_BN_CLICKED(IDC_BTN_DisableHWCyclicTxMsg, &CDemo1Dlg::OnBnClickedBtnDisablehwcyclictxmsg)
	ON_BN_CLICKED(IDC_BTN_VCI_EnableHWCyclicTxMsgNo, &CDemo1Dlg::OnBnClickedBtnVciEnablehwcyclictxmsgno)
	ON_BN_CLICKED(IDC_BTN_VCI_EnableHWCyclicTxMsgNo_Ex, &CDemo1Dlg::OnBnClickedBtnVciEnablehwcyclictxmsgnoEx)
	ON_BN_CLICKED(IDC_BTN_VCI_DisableHWCyclicTxMsgNo, &CDemo1Dlg::OnBnClickedBtnVciDisablehwcyclictxmsgno)
	ON_BN_CLICKED(IDC_BTN_Set_UserDefISR, &CDemo1Dlg::OnBnClickedBtnSetUserdefisr)
	ON_BN_CLICKED(IDC_BTN_Clr_UserDefISR, &CDemo1Dlg::OnBnClickedBtnClrUserdefisr)
	ON_BN_CLICKED(IDC_BTN_Get_ISRCANData, &CDemo1Dlg::OnBnClickedBtnGetIsrcandata)
	ON_BN_CLICKED(IDC_BTN_RxMsgCount, &CDemo1Dlg::OnBnClickedBtnRxmsgcount)
	ON_BN_CLICKED(IDC_BTN_RxSoftBufFull, &CDemo1Dlg::OnBnClickedBtnRxsoftbuffull)
	ON_BN_CLICKED(IDC_BTN_ClrSoftBuffer, &CDemo1Dlg::OnBnClickedBtnClrsoftbuffer)
	ON_BN_CLICKED(IDC_BTN_GetDllVer, &CDemo1Dlg::OnBnClickedBtnGetdllver)
	ON_CBN_SELCHANGE(IDC_COMBO_ComPort, &CDemo1Dlg::OnCbnSelchangeComboComport)
	ON_CBN_SELCHANGE(IDC_COMBO_DevType, &CDemo1Dlg::OnCbnSelchangeComboDevtype)
	ON_CBN_SELCHANGE(IDC_COMBO_CANCtrlNo, &CDemo1Dlg::OnCbnSelchangeComboCanctrlno)
END_MESSAGE_MAP()


// CDemo1Dlg message handlers

BOOL CDemo1Dlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	for(int i=1; i<=255; i++){
		TmpMsg.Format(_T("COM%d"), i);
		m_ComPort.AddString(TmpMsg);
	}
	m_ComPort.SetCurSel(12);
	ComPort=m_ComPort.GetCurSel()+1;
	for(int i=1; i<=2; i++){
		TmpMsg.Format(_T("I-7565-H%d"), i);
		m_DevType.AddString(TmpMsg);
	}
	m_DevType.SetCurSel(1);
	m_CANBaud.AddString(_T("5"));
	m_CANBaud.AddString(_T("10"));
	m_CANBaud.AddString(_T("20"));
	m_CANBaud.AddString(_T("40"));
	m_CANBaud.AddString(_T("50"));
	m_CANBaud.AddString(_T("80"));
	m_CANBaud.AddString(_T("100"));
	m_CANBaud.AddString(_T("125"));
	m_CANBaud.AddString(_T("200"));
	m_CANBaud.AddString(_T("250"));
	m_CANBaud.AddString(_T("400"));
	m_CANBaud.AddString(_T("500"));
	m_CANBaud.AddString(_T("600"));
	m_CANBaud.AddString(_T("800"));
	m_CANBaud.AddString(_T("1000"));
	m_CANBaud.SetCurSel(14);
	m_CANBaud2.AddString(_T("5"));
	m_CANBaud2.AddString(_T("10"));
	m_CANBaud2.AddString(_T("20"));
	m_CANBaud2.AddString(_T("40"));
	m_CANBaud2.AddString(_T("50"));
	m_CANBaud2.AddString(_T("80"));
	m_CANBaud2.AddString(_T("100"));
	m_CANBaud2.AddString(_T("125"));
	m_CANBaud2.AddString(_T("200"));
	m_CANBaud2.AddString(_T("250"));
	m_CANBaud2.AddString(_T("400"));
	m_CANBaud2.AddString(_T("500"));
	m_CANBaud2.AddString(_T("600"));
	m_CANBaud2.AddString(_T("800"));
	m_CANBaud2.AddString(_T("1000"));
	m_CANBaud2.SetCurSel(14);

	m_CANCtrlNo.AddString(_T("CAN1"));
	m_CANCtrlNo.AddString(_T("CAN2"));
	m_CANCtrlNo.SetCurSel(0);
	CAN_No=m_CANCtrlNo.GetCurSel()+1;
	m_CANCtrlNo.EnableWindow(FALSE);

	m_BtnCloseCAN.EnableWindow(FALSE);
	if((m_DevType.GetCurSel()+1)==I7565H1){
		m_CANBaud2.EnableWindow(FALSE);
	}

	PortClose_ButtonFunc();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemo1Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemo1Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemo1Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CDemo1Dlg::Show_ErrCode(int ErrCode)
{
	TmpMsg.Format(_T("ErrCode= %ld\nErrMesg= \"%S\""), ErrCode, ErrMessage[ErrCode]);
	m_ResStr.SetWindowText(TmpMsg);	
	//AfxMessageBox(TmpMsg);
}


void CDemo1Dlg::OnBnClickedBtnOpencom()
{
	CString Tmp_CANBaud;
	//char* endptr;	
	_VCI_CAN_PARAM pCANPARAM;

	pCANPARAM.DevPort = ComPort;
	pCANPARAM.DevType = m_DevType.GetCurSel()+1;

	m_CANBaud.GetWindowText(Tmp_CANBaud);
	pCANPARAM.CAN1_Baud = (DWORD)(_wtof(Tmp_CANBaud)*1000);			//Ex: 83.333K => 83333
	m_CANBaud2.GetWindowText(Tmp_CANBaud);
	pCANPARAM.CAN2_Baud = (DWORD)(_wtof(Tmp_CANBaud)*1000);

	m_ResStr.SetWindowText(_T("Waiting for Connect ..."));
	VCI_DoEvents();

	Ret = VCI_OpenCAN(&pCANPARAM);
	if(Ret == No_Err){
		PortOpen_ButtonFunc();
		//AfxBeginThread(CANRx_Thread, NULL);

		TmpMsg.Format(_T("OpenCAN Success"));
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}
}


void CDemo1Dlg::OnBnClickedBtnClosecan()
{
	Ret = VCI_CloseCAN(ComPort);
	if(Ret == No_Err){
		PortClose_ButtonFunc();
		OnCbnSelchangeComboDevtype();

		TmpMsg.Format(_T("CloseCAN Success"));
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}
}


void CDemo1Dlg::OnBnClickedBtnSetcanfid()
{
	_VCI_CAN_FilterID pCANFID1;
	WORD  SSFID[3]={0x0003, 0x0002, 0x0001};							//Single Standard FID (11-bit)
	DWORD GSFID[2]={0x00300040, 0x00100020};							//Group  Standard FID (11-bit)	
	DWORD SEFID[3]={0x00000013, 0x00000012, 0x00000011};				//Single Extended FID (29-bit)
	DWORD GEFID[4]={0x00000300, 0x00000400, 0x00000100, 0x00000200};	//Group  Extended FID (29-bit)	

	m_BtnSetCANFID.EnableWindow(FALSE);

	pCANFID1.SSFF_Num = sizeof(SSFID)/sizeof(WORD);	
	pCANFID1.GSFF_Num = sizeof(GSFID)/sizeof(DWORD);
	pCANFID1.SEFF_Num = sizeof(SEFID)/sizeof(DWORD);
	pCANFID1.GEFF_Num = sizeof(GEFID)/sizeof(DWORD);
	/*TmpMsg.Format("SSFFLen=%d; GSFF_Len=%d; SEFF_Len=%d, GEFF_Len=%d", 
				   pCANFID1.SSFF_Num, pCANFID1.GSFF_Num, pCANFID1.SEFF_Num, pCANFID1.GEFF_Num);
	AfxMessageBox(TmpMsg);*/

	//pCANFID1.SSFF_FID = SSFID;
	//pCANFID1.GSFF_FID = GSFID;
	//pCANFID1.SEFF_FID = SEFID;
	//pCANFID1.GEFF_FID = GEFID;
	memcpy(pCANFID1.SSFF_FID, SSFID, pCANFID1.SSFF_Num*2);
	memcpy(pCANFID1.GSFF_FID, GSFID, pCANFID1.GSFF_Num*4);
	memcpy(pCANFID1.SEFF_FID, SEFID, pCANFID1.SEFF_Num*4);
	memcpy(pCANFID1.GEFF_FID, GEFID, pCANFID1.GEFF_Num*4);

	Ret = VCI_Set_CANFID(CAN_No, &pCANFID1);
	if(Ret == No_Err){
		TmpMsg.Format(_T("Set CAN%d_FID OK"), CAN_No);
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);	
	}

	Sleep(100);
	m_BtnSetCANFID.EnableWindow(TRUE);
}


void CDemo1Dlg::OnBnClickedBtnGetcanfid()
{
	_VCI_CAN_FilterID CANFID;
	WORD SID11_EndNum=0, GID11_EndNum=0, SID29_EndNum=0, GID29_EndNum=0;
	

	m_BtnGetCANFID.EnableWindow(FALSE);

	Ret = VCI_Get_CANFID(CAN_No, &CANFID);
	if(Ret == No_Err){
		SID11_EndNum = CANFID.SSFF_Num;
		GID11_EndNum = CANFID.GSFF_Num;
		SID29_EndNum = CANFID.SEFF_Num;
		GID29_EndNum = CANFID.GEFF_Num;

		//TmpMsg.Format("Get CAN%d_FID OK", CAN_No);
		//m_ResStr.SetWindowText(TmpMsg);	

		/* Show CANFID Number */
		TmpMsg.Format(_T("SID11_EndNum=%d;  GID11_EndNum=%d;  SID29_EndNum=%d;  GID29_EndNum=%d"), 
					   SID11_EndNum, GID11_EndNum, SID29_EndNum, GID29_EndNum);
		m_ResStr.SetWindowText(TmpMsg);
		Sleep(1000);

		/* Show CANFID Data */
// 		if(SID11_EndNum > 0){			
// 			for(i=0; i<SID11_EndNum; i++){
// 				TmpMsg.Format(_T(""SID11_Arr[%d]=0x%04X; "), i, CANFID.SSFF_FID[i]);
// 				m_ResStr.SetWindowText(TmpMsg);
// 				Sleep(1000);
// 			}
// 			Sleep(1000);
// 		}
// 		if(GID11_EndNum > 0){
// 			for(i=0; i<GID11_EndNum; i++){
// 				TmpMsg.Format(_T(""GID11_Arr[%d]=0x%08X"), i, CANFID.GSFF_FID[i]);
// 				m_ResStr.SetWindowText(TmpMsg);
// 				Sleep(1000);
// 			}
// 			Sleep(1000);
// 		}
// 		if(SID29_EndNum > 0){
// 			for(i=0; i<SID29_EndNum; i++){
// 				TmpMsg.Format(_T(""SID29_Arr[%d]=0x%08X"), i, CANFID.SEFF_FID[i]);
// 				m_ResStr.SetWindowText(TmpMsg);
// 				Sleep(50);
// 			}
// 			Sleep(1000);
// 		}
// 		if(GID29_EndNum > 0){
// 			for(i=0; i<GID29_EndNum; i++){
// 				TmpMsg.Format(_T(""GID29_Arr[%d]=0x%08X"), i, CANFID.GEFF_FID[i]);
// 				m_ResStr.SetWindowText(TmpMsg);
// 				Sleep(50);
// 			}
// 		}
	}
	else{
		Show_ErrCode(Ret);		
	}
	
	Sleep(100);
	m_BtnGetCANFID.EnableWindow(TRUE);
}


void CDemo1Dlg::OnBnClickedBtnVciSetCanfidAllpass()
{
	m_BtnSetFIDAllPass.EnableWindow(FALSE);
	
	Ret = VCI_Set_CANFID_AllPass(1);	
	if(Ret == No_Err){
		TmpMsg.Format(_T("Set CAN%d_FID All Pass OK"), CAN_No);
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);	
	}

	Sleep(100);
	m_BtnSetFIDAllPass.EnableWindow(TRUE);
}


void CDemo1Dlg::OnBnClickedBtnGetcanstatus()
{
	_VCI_CAN_STATUS CANSTA;

	m_BtnGetCANSta.EnableWindow(FALSE);
	Ret = VCI_Get_CANStatus(CAN_No, &CANSTA);
	if(Ret == No_Err){
		TmpMsg.Format(_T("[ CAN%d_Status :]\nBAUDRATE  => %6.3f (Kbps)\nREGISTER     => 0x%02X\nTXERRCNT   => 0x%02X\nRXERRCNT   => 0x%02X\nMODSTATE   => 0x%02X"), CAN_No, (float)CANSTA.CurCANBaud/1000, CANSTA.CANReg, CANSTA.CANTxErrCnt, CANSTA.CANRxErrCnt, CANSTA.MODState);
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}
	
	Sleep(100);
	m_BtnGetCANSta.EnableWindow(TRUE);
}


void CDemo1Dlg::OnBnClickedBtnClrbufferfullled()
{
	m_BtnClrBufFullLED.EnableWindow(FALSE);

	Ret = VCI_Clr_BufOverflowLED(CAN_No);
	if(Ret == No_Err){
		TmpMsg.Format(_T("Clear CAN%d ERRLED OK"), CAN_No);
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}
	
	Sleep(100);
	m_BtnClrBufFullLED.EnableWindow(TRUE);
}


void CDemo1Dlg::OnBnClickedBtnGetmodinfo()
{
	_VCI_MODULE_INFO CAN_ModInfo;


	m_BtnGetModInfo.EnableWindow(FALSE);
	Ret = VCI_Get_MODInfo(&CAN_ModInfo);
	if(Ret == No_Err){
		TmpMsg.Format(_T("Module_Name  => %S\nFirmware_Ver  => %S\nHardware_SN  => %S"), CAN_ModInfo.Mod_ID, CAN_ModInfo.FW_Ver, CAN_ModInfo.HW_SN);
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}

	Sleep(100);
	m_BtnGetModInfo.EnableWindow(TRUE);
}


void CDemo1Dlg::OnBnClickedBtnResetmod()
{
	Ret = VCI_Rst_MOD();
	if(Ret == CAN_DevDisconnect_Err){
		PortClose_ButtonFunc();
		OnCbnSelchangeComboDevtype();

		TmpMsg.Format(_T("Reset Module Success"));
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}
}


void CDemo1Dlg::OnBnClickedBtnCansend()
{
	_VCI_CAN_MSG CAN_SendMsg;
	//int i;


	CAN_SendMsg.Mode	= 0;
	CAN_SendMsg.RTR		= 0;
	CAN_SendMsg.ID		= 0x100;
	CAN_SendMsg.DLC		= 8;
	CAN_SendMsg.Data[0]	= 0x12;
	CAN_SendMsg.Data[1]	= 0x34;
	CAN_SendMsg.Data[2]	= 0x56;
	CAN_SendMsg.Data[3]	= 0x78;
	CAN_SendMsg.Data[4]	= 0x90;
	CAN_SendMsg.Data[5]	= 0xAB;
	CAN_SendMsg.Data[6]	= 0xCD;
	CAN_SendMsg.Data[7]	= 0xEF;

	
	//for(i=0; i<100; i++){
		Ret = VCI_SendCANMsg(CAN_No, &CAN_SendMsg);
		//Sleep(1);
	//}

	if(Ret == No_Err){
		Show_ErrCode(Ret);
		//TmpMsg.Format(_T("Send CAN%d_Msg OK"), CAN_No);
		//m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}
}


void CDemo1Dlg::OnBnClickedBtnCanrecv()
{
	_VCI_CAN_MSG CAN_RecvMsg;
	
	memset(CAN_RecvMsg.Data, 0, sizeof(CAN_RecvMsg.Data));
	Ret = VCI_RecvCANMsg(CAN_No, &CAN_RecvMsg);
	if(Ret == No_Err){		
		TmpMsg.Format(_T("MODE      => %d\nID             => 0x%08X\nRTR          => %d\nDLC          => %d\nDATA_L   => 0x%08X\nDATA_H   => 0x%08X\nMsg_Time => %5.4f (sec)"), CAN_RecvMsg.Mode, CAN_RecvMsg.ID, CAN_RecvMsg.RTR, CAN_RecvMsg.DLC, *(DWORD*)&CAN_RecvMsg.Data[0], *(DWORD*)&CAN_RecvMsg.Data[4], ((double)((double)CAN_RecvMsg.TimeH*pow(2.0,32.0)+(double)CAN_RecvMsg.TimeL)/10000));
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}
}


void CDemo1Dlg::OnBnClickedBtnHwcyclicSendcanmsg()
{
	_VCI_CAN_MSG CAN_SendMsg;	

	CAN_SendMsg.Mode	= 1;
	CAN_SendMsg.RTR		= 0;
	CAN_SendMsg.ID		= 0x1;
	CAN_SendMsg.DLC		= 8;
	CAN_SendMsg.Data[0]	= 0x12;
	CAN_SendMsg.Data[1]	= 0x34;
	CAN_SendMsg.Data[2]	= 0x56;
	CAN_SendMsg.Data[3]	= 0x78;
	CAN_SendMsg.Data[4]	= 0x90;
	CAN_SendMsg.Data[5]	= 0xAB;
	CAN_SendMsg.Data[6]	= 0xCD;
	CAN_SendMsg.Data[7]	= 0xEF;	

	Ret = VCI_EnableHWCyclicTxMsg(CAN_No, &CAN_SendMsg, 10, 200);				//Send 200 CANMsg with 10ms period and Stop
	//Ret = VCI_EnableHWCyclicTxMsg(CAN_No, &CAN_SendMsg, TPFLOATMS(0.5), 200);	//Send 200 CANMsg with 0.5ms period and Stop
	//Ret = VCI_EnableHWCyclicTxMsg(CAN_No, &CAN_SendMsg, TPFLOATMS(2.5), 200);	//Send 200 CANMsg with 2.5ms period and Stop
	//Ret = VCI_EnableHWCyclicTxMsg(CAN_No, &CAN_SendMsg, 10, 0);				//Send CANMsg Continuously
	if(Ret == No_Err){
		TmpMsg.Format(_T("HWCyclic_SendCAN%dMsg Start"), CAN_No);
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}
}


void CDemo1Dlg::OnBnClickedBtnDisablehwcyclictxmsg()
{
	Ret = VCI_DisableHWCyclicTxMsg();
	if(Ret == No_Err){
		TmpMsg.Format(_T("HWCyclic_SendCAN%dMsg Stop"), CAN_No);
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}
}


void CDemo1Dlg::OnBnClickedBtnVciEnablehwcyclictxmsgno()
{
	BYTE Mode, RTR, DLC, Data[8], HW_TimerNo;
	DWORD ID;
	
	Mode	= 1;
	RTR		= 0;
	ID		= 0x1;
	DLC		= 8;
	Data[0]	= 0x12;
	Data[1]	= 0x34;
	Data[2]	= 0x56;
	Data[3]	= 0x78;
	Data[4]	= 0x90;
	Data[5]	= 0xAB;
	Data[6]	= 0xCD;
	Data[7]	= 0xEF;	

	//Send 200 CANMsg with 10ms period and Stop by using HWSendTimer-01
	HW_TimerNo = 1;	
	Ret = VCI_EnableHWCyclicTxMsgNo(CAN_No, Mode, RTR, DLC, ID, Data, 10, 200, HW_TimerNo);
	if(Ret == No_Err){
		TmpMsg.Format(_T("HWTimer%d_SendCAN%dMsg Start"), HW_TimerNo, CAN_No);
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}
}


void CDemo1Dlg::OnBnClickedBtnVciEnablehwcyclictxmsgnoEx()
{
	BYTE Mode, RTR, DLC, Data[8], HW_TimerNo;
	DWORD ID;
	
	Mode	= 1;
	RTR		= 0;
	ID		= 0x1;
	DLC		= 8;
	Data[0]	= 0x00;
	Data[1]	= 0x00;
	Data[2]	= 0x00;
	Data[3]	= 0x00;
	Data[4]	= 0x00;
	Data[5]	= 0x00;
	Data[6]	= 0x00;
	Data[7]	= 0x00;	
	
	//Send 200 CANMsg with 10ms period and Stop by using HWSendTimer-01
	//CANL_Data Value will be added by 1 every time
	//CANH_Data Value will be added by 2 every time
	HW_TimerNo = 1;	
	Ret = VCI_EnableHWCyclicTxMsgNo_Ex(CAN_No, Mode, RTR, DLC, ID, Data, 10, 200, HW_TimerNo, ADDITION_MODE, 1, 2);
	if(Ret == No_Err){
		TmpMsg.Format(_T("HWTimer%d_SendCAN%dMsg Start"), HW_TimerNo, CAN_No);
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}
}


void CDemo1Dlg::OnBnClickedBtnVciDisablehwcyclictxmsgno()
{
	BYTE HW_TimerNo;

	//Stop HWSendTimer-01
	HW_TimerNo = 1;
	Ret = VCI_DisableHWCyclicTxMsgNo(HW_TimerNo);	
	if(Ret == No_Err){
		TmpMsg.Format(_T("HWTimer%d_SendCAN%dMsg Stop"), HW_TimerNo, CAN_No);
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}
}


void CDemo1Dlg::OnBnClickedBtnSetUserdefisr()
{
	MyTest0_Val=0;
	MyTest1_Val=0;

	/* Enable UserDefISR Function */
	//The UserDefISR (MyTestISR0) will be trigged when receiving any one CANMsg
	Ret=VCI_Set_UserDefISR(ISRNO_0, ISR_CANPORT_ALL, ISR_CANMODE_ALL, ISR_CANID_ALL, MyTestISR0);

	//The UserDefISR (MyTestISR1) will be trigged when only CAN1 receiving 11-bit CANMsg with CANID=0x100
	Ret=VCI_Set_UserDefISR(ISRNO_1, CAN1, MODE_11BIT, 0x100, MyTestISR1);	
	
	if(Ret == No_Err){
		TmpMsg.Format(_T("Set UserDefISR OK"));
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}
}


void CDemo1Dlg::OnBnClickedBtnClrUserdefisr()
{
	/* Disable UserDefISR Function */
	VCI_Clr_UserDefISR(ISRNO_0);
	VCI_Clr_UserDefISR(ISRNO_1);
	
	TmpMsg.Format(_T("ISR0_Val=%lu, ISR1_Val=%lu"), MyTest0_Val, MyTest1_Val);
	AfxMessageBox(TmpMsg);	
}


void CDemo1Dlg::OnBnClickedBtnGetIsrcandata()
{
	BYTE ISR1_CANDataLen, ISR1_CANData[8]={0};

	VCI_Get_ISRCANData(ISRNO_1, &ISR1_CANDataLen, ISR1_CANData);
	TmpMsg.Format(_T("ISR1_Data(%d) = %02X_%02X_%02X_%02X_%02X_%02X_%02X_%02X"), ISR1_CANDataLen,
					ISR1_CANData[0], ISR1_CANData[1], ISR1_CANData[2], ISR1_CANData[3],
					ISR1_CANData[4], ISR1_CANData[5], ISR1_CANData[6], ISR1_CANData[7]);
	m_ResStr.SetWindowText(TmpMsg);
}


void CDemo1Dlg::OnBnClickedBtnRxmsgcount()
{
	DWORD RxMsgCnt;

	Ret = VCI_Get_RxMsgCnt(CAN_No, &RxMsgCnt);
	if(Ret == No_Err){
		TmpMsg.Format(_T("CAN%d RxMsgCnt= %d"), CAN_No, RxMsgCnt);		
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}
}


void CDemo1Dlg::OnBnClickedBtnRxsoftbuffull()
{
	BYTE RxSoftBufFull_Flag;

	Ret = VCI_Get_RxMsgBufIsFull(CAN_No, &RxSoftBufFull_Flag);
	if(Ret == No_Err){
		TmpMsg.Format(_T("CAN%d RxMsgBuf FullFlag= %d"), CAN_No, RxSoftBufFull_Flag);	
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}
}


void CDemo1Dlg::OnBnClickedBtnClrsoftbuffer()
{
	Ret = VCI_Clr_RxMsgBuf(CAN_No);
	if(Ret == No_Err){	
		TmpMsg.Format(_T("Clear CAN%d RxSoftBuffer OK"), CAN_No);
		m_ResStr.SetWindowText(TmpMsg);
	}
	else{
		Show_ErrCode(Ret);
	}
}


void CDemo1Dlg::OnBnClickedBtnGetdllver()
{
	DWORD DllVer;

	DllVer = VCI_Get_DllVer();
	TmpMsg.Format(_T("VCI_DllVer= v%lu.%02lu"), (DllVer>>8)&0xFF, DllVer&0xFF);
	m_ResStr.SetWindowText(TmpMsg);	
}


void CDemo1Dlg::PortOpen_ButtonFunc(void)
{
	m_ComPort.EnableWindow(FALSE);
	m_DevType.EnableWindow(FALSE);
	m_CANBaud.EnableWindow(FALSE);
	m_CANBaud2.EnableWindow(FALSE);
	m_BtnOpenCAN.EnableWindow(FALSE);

	m_BtnCloseCAN.EnableWindow(TRUE);
	m_CANCtrlNo.EnableWindow(TRUE);
	m_BtnSetCANFID.EnableWindow(TRUE);
	m_BtnGetCANFID.EnableWindow(TRUE);
	m_BtnGetCANSta.EnableWindow(TRUE);
	m_BtnClrBufFullLED.EnableWindow(TRUE);
	m_BtnGetModInfo.EnableWindow(TRUE);
	m_BtnRstMod.EnableWindow(TRUE);
	m_BtnCANSend.EnableWindow(TRUE);
	m_BtnCANRecv.EnableWindow(TRUE);
	m_BtnEnHWCyclicTxMsg.EnableWindow(TRUE);
	m_BtnDisHWCyclicTxMsg.EnableWindow(TRUE);
}


void CDemo1Dlg::PortClose_ButtonFunc(void)
{
	m_ComPort.EnableWindow(TRUE);
	m_DevType.EnableWindow(TRUE);
	m_CANBaud.EnableWindow(TRUE);
	m_CANBaud2.EnableWindow(TRUE);
	m_BtnOpenCAN.EnableWindow(TRUE);
	
	m_BtnCloseCAN.EnableWindow(FALSE);
	m_CANCtrlNo.EnableWindow(FALSE);
	m_BtnSetCANFID.EnableWindow(FALSE);
	m_BtnGetCANFID.EnableWindow(FALSE);
	m_BtnGetCANSta.EnableWindow(FALSE);
	m_BtnClrBufFullLED.EnableWindow(FALSE);
	m_BtnGetModInfo.EnableWindow(FALSE);
	m_BtnRstMod.EnableWindow(FALSE);
	m_BtnCANSend.EnableWindow(FALSE);
	m_BtnCANRecv.EnableWindow(FALSE);
	m_BtnEnHWCyclicTxMsg.EnableWindow(FALSE);
	m_BtnDisHWCyclicTxMsg.EnableWindow(FALSE);
}


void CDemo1Dlg::OnCbnSelchangeComboComport()
{
	ComPort = m_ComPort.GetCurSel()+1;
}


void CDemo1Dlg::OnCbnSelchangeComboDevtype()
{
	if((m_DevType.GetCurSel()+1) == I7565H1){
		m_CANBaud2.EnableWindow(FALSE);
	}
	else if((m_DevType.GetCurSel()+1) == I7565H2){
		m_CANBaud2.EnableWindow(TRUE);
	}
}


void CDemo1Dlg::OnCbnSelchangeComboCanctrlno()
{
	if(m_CANCtrlNo.GetCurSel()==1){					//Choose CAN2 Port
		if((m_DevType.GetCurSel()+1)==I7565H1){		//Module => I-7565-H1
			m_CANCtrlNo.SetCurSel(0);
			m_ResStr.SetWindowText(_T("CAN2 doesn't support in I-7565-H1"));
		}
		else{
			CAN_No = m_CANCtrlNo.GetCurSel()+1;
		}
	}
	else{
		CAN_No = m_CANCtrlNo.GetCurSel()+1;
	}
}

